<?php
/*
Plugin Name: Posts Character Count Admin
Description: Displays a column with the character count for each post in the Manage Posts SubPanel and in the Edit Pots SubPanel
Plugin URI:  http://www.officetrend.de/2061/wordpress-plugin-posts-character-count-admin-zeichen-laenge-der-artikel/
Version:     1.1
Author:      Tanja Preu&szlig;e
Author URI:  http://www.officetrend.de/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

if (function_exists('load_plugin_textdomain'))
load_plugin_textdomain('posts-character-count-admin', PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/languages', dirname(plugin_basename(__FILE__)).'/languages');

//Filters and Functions for column in the Manage Posts SubPanel
add_filter('manage_posts_columns', 'pcca_count_characters');

function pcca_count_characters($defaults) {
    $defaults['count'] = __('Character Count', 'posts-character-count-admin');
    return $defaults;
}

add_action('manage_posts_custom_column', 'pcca_count_custom_column', 10, 2);

function pcca_count_custom_column($column, $post_id)
{
	global $post;
	if($column == 'count') {
		$pcca_char_count = strip_tags($post->post_content);
		echo strlen(utf8_decode($pcca_char_count)).' '. __(' characters', 'posts-character-count-admin');
		//$pcca_char_count = utf8_decode($post->post_content);
		//echo strlen(strip_tags(utf8_decode($pcca_char_count))).' '. __(' characters', 'posts-character-count-admin');
		
	}
}

//Class, Function and Action for Display Characters Count in the Edit Posts SubPanel
class CharactersCountPcca {
	var $text;
	var $characters;
	
	function set_text($text) {
		$this->text = strip_tags($text);	
		//$this->text = strip_tags(utf8_decode($text));	
		$this->characters = -1;
	}
	
	function get_text() {
		return($this->text);
	}
	
	function get_characters() {
		if ($this->text == '') { return(0); }		
		if ($this->characters != -1) { return($this->characters); }
				
		$count = strlen(utf8_decode($this->text));
		
		$this->characters = $count;
		return($count);
	}
}

function pcca_characters_count_admin_footer() {
	global $wpdb;
	global $post;

	if ($post->post_content != '') {
		$stat = new CharactersCountPcca;
		$stat->set_text($post->post_content);

		$template = '';
		$template = '<span class="inside">'. __('Character count:', 'posts-character-count-admin').' %d '. __('characters (incl. spaces)', 'posts-character-count-admin').'</span> ';
		$pluginHTML = sprintf($template,
				$stat->get_characters()				);
		printf('<script language="javascript" type="text/javascript">
				var div = document.getElementById("post-status-info");
				if (div != undefined) {
					div.innerHTML = div.innerHTML + \'%s\';
				}
				</script>', str_replace("'", "\'", $pluginHTML)
			);
	}
}

add_action('admin_footer', 'pcca_characters_count_admin_footer');
?>